/*
 *	nppowerd.c          cc -arch m68k -Wall nppowerd.c -s -o nppowerd
 *
 *      (c) 1996 Gerald Erdmann (NEXTOYOU)
 *
 *      This daemon turns off your NeXTlaser (/dev/np0) if it isn't used
 *      for "interval" minutes.
 *
 *      Diese Daemon schaltet den NeXTlaser (/dev/np0) aus, sobald dieser
 *      mehr als "interval" Minuten nicht benutzt wurde.
 *
 *	Usage:  nppowerd [interval minutes]
 *
 */

#define INTERVAL 300

#include <stdio.h>
#include <libc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dev/m68k/npio.h>

time_t modtime ()
{
    struct stat pstat;

    if (stat ("/dev/np0", &pstat) < 0) {
        fputs("nppowerd: ", stderr);
        perror ("/dev/np0");
        exit (1);
    }

    return pstat.st_mtime;
}

int main (int argc, char *argv[])
{
    time_t      offtime, mtime, idle;
    int         interval = INTERVAL;

    if (argc > 2) {
        fputs ("Usage: nppowerd [minutes]\n", stderr);
        exit (1);
    }

    if (fork ())
        exit (0);

    if (argc > 1)
        interval = atoi(argv[1]) * 60;
    if ((interval < 60) || (interval > (24 * 60 * 60)))
        interval = INTERVAL;

    sleep (10);
    for (offtime = 0, mtime = modtime ();; mtime = modtime ()) {
        if (mtime != offtime) {
            while ((idle = time (NULL) - mtime) < interval) {
                sleep (interval - idle + 1);
                mtime = modtime();
            }
            system ("/usr/etc/nppower off");
            offtime = mtime = modtime ();
        }
        sleep (interval);
    }

    exit (0);
}
